{ Unit: BcWebLabel
  ===========================================================================

  The contents of this file are subject to the Bluecave Limited License V 1.0
  (the "License"). You may not copy or use this file, in either source code
  or executable form, except in compliance with the License. You may obtain
  a copy of the License at http://www.bluecave.net/licenses/.

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
  for the specific language governing rights and limitations under the
  License.

  Copyright (C) 1999-2002 Bluecave Software. All Rights Reserved.
  http://www.bluecave.net/

  Copyright (C) 1999-2002 Jouni Airaksinen. All Rights Reserved.
  http://Mintus.Codefield.com/ -- Mintus@Codefield.com

{ ===========================================================================

  Works in (tested):
  ==================
    - Delphi 6
    - Delphi 5
    - Delphi 4

  Installation:
  =============

    Read Readme.txt of Bluecave Components package.

    This component should work with Delphi 3 and probably Delphi 2 too. Tell
    me if does or doesn't.

  ---------------------------------------------------------------------------

  History:
  ========

  Version 2.2.2 (2001-10-16)
  - Fixed bug with CaptureMouse and losing the capture. If HotTrack was
    used the link font was not reset always.

  Version 2.2.1 (2001-10-11)
  - Changed Language string array definition a bit
  - Moved Register procedure to different designtime unit
  - Included the TBcWebLabel to my Bluecave Components package
  - Changed classname to TBcWebLabel. Edit your dfm sources as text
    to convert stuff. Defaults with no Drag & Drop Suite support.

  Version 2.2.0 (2001-09-18)
  - CaptureMouse property. It will use different method to detect mouse
    enter and leave. Use this if you are doing DLL file which is going to be
    used in non-VCL application. You can use it in VCL applications as well,
    but then you are wasting window handle resources.

  Version 2.1.6 (2000-10-16)
  - Copy to clipboard has some small bug. It doesn't copy anything to clipboard,
    if CF_TEXT format doesn't exists. I removed the format checking now, but
    I think it causes Access Violation now..? Atleast this is what Delphi
    help claims. I wonder how this can be fixed as CF_TEXT should be one of the
    pre-registered formats..
  - Made the code a bit more clear to read.

  Version 2.1.5 (2000-07-19)
  - Support for DragDrop Component Suite 4.00 (tested with beta version)

  Version 2.1.4 (2000-06-23)
  - No changes, only new COPYRIGHT, FEES & DISCLAIMER section.
    NO PANIC: No changes or restrictions in using this; everything like before.
    Only explaned my rights better.

  Version 2.1.3 (2000-06-23)
  - Non-drag and drop version had compiler "Hint"
  - Dutch language, thanks to IceRoms
  - German language, thanks to phx|yogi
  - Icelandic language, thanks to xenophon
  - Made new component tray icon. Sorry [Panther], your dcr file didn't work :/

    If you are upgrading, you need to uninstall component first to activate
    new icon.
    Uninstalling: remove WebLabel.pas from package you installed it,
      re-compile the package. Delphi should now tell that TBcWebLabel has been
      unregistered. Install component normally.

  Version 2.1.2 (2000-06-11)
  - Support for Italian language.
    Thanks goes to [Panther], pnt.dcc@libero.it, http://web.tiscalinet.it/panther

  Version 2.1.1 (2000-04-16)
  - Default Cursor is now crHandPoint.

  Version 2.1.0 (later .. 2000-04-08)
  - Fixed bug with HotTrack.
  - Fixed that no Drag and Drop will not happen if URL is empty. URL gets title
    from ShowURL field. if suNone, then title is same as URL. Title is used e.g.
    when dragging URL to open folder or desktop. Explorer creates .url file
    (also know as MSIE Bookmark) which has title as name.
  - Changed HotTrackColor and LinkActivateColor to HotTrackFont and ActiveFont.
    So now you can even change font properties for different states...
  - Removed UseColorChange property. No need for this.. Just set ActiveFont
    to same as normal Font.
  - Removed DragURL property (if compiled as non-drag-drop version).
  - Removed unnessary units from uses line.
  - Notes about Threads; Thread is create when it's needed and destroyed
    after it has done it's job. So, no need to worry about getting lots
    of threads.

  Version 2.0.0 (2000-04-08) -- Uuuhh.. major update :)
  - Changed HTTPAddess property to URL. (Sorry guys/girls, but URL is more
    descriptive :)
  - Made browser executing multithreaded. So, now cursor changes to AppStart
    (the one with a arrow and an hourglass) and browser starts in the background
    while your app continues running normally (dragging, focusing, etc, work
    normally like nothing would have happened).
  - Added ClipboardText property. This is what goes to clipboard. If nothing
    here then it's URL property. This comes handy when e.g. using
    'mailto:Mintus@Codefield.com' URL to send e-mail. You probably would like
    to have just 'Mintus@Codefield.com' or
    '"Jouni Airaksinen" <Mintus@Codefield.com>' to clipboard.
  - Added Drag and Drop support. It drags URL as real URL object. If ClipboardText
    property has text in it, then it's content is dragged as text instead.
    This REQUIRES Drag and Drop Component Suite.
    You can find it from http://www.melander.dk. It's freeware. If you don't
    want drag and drop support remove (or comment out) DRAGDROP definition
    at the start of this unit. To disable drag and drop locally you can use
    DragURL property, without Drag and Drop support this property doesn't do
    anything.
  - Added HotTrack. To enable use HotTrack property, and HotTrackColor to change
    hottrack color.
  - Added language support!! Yeeehoo! Send other languages to me if you want
    them to be included to internal language list. Meanwhile you can use
    CustomLanguage property. Just write two strings there. First is 'Open' and
    second 'Copy to clipboard'. If there are no strings, internal language
    is used. Note, missing strings are taken from internal language. So,
    if you want just to change Open text (e.g. to 'Send e-mail'), just put
    that line to CustomLanguage and copy to clipboard text is taken from
    internal language.
  - Added ShowURL property. It shows additional text in popupmenu. Changing
    ShowURL property you control where it takes that text. Property values
    should be quite self-explaining.
  - Added GotoURL method. It just launches what click would do.
  - Added OnExecute method. It's called just before URL is executed.
    By setting AllowExecute you can set, if URL is actually executed.
  - Added browser OpenStyle property. soCustom takes open style from Tag
    property. Info about possible flags see ShellExecute.
  - Removed UseCursorChange property, as actually you don't need it.. just
    use derived Cursor property of TLabel instead.
  - Removed LinkColor property. Use Font.Color instead.
    Prior activation Font.Color is stored and restored after deactivation.
    If you change color during activated state, your change is lost.

  Version 1.1.0
  - Added OnMouseEnter/OnMouseLeave events
  - Added MouseIn: boolean property
  - Added UseColorChange, UseCursorChange, UsePopup: boolean properties

  Version 1.0.0
  - First personal release.. ;)

  =========================================================================== }

{$I DFS.inc}
{$I BcDirectives.inc}

unit BcWebLabel;
{ If you are using DragDrop 4.00 please select it here. Unit names have been
  changed. SELECT ONLY ONE VERSION (It won't compile otherwise..) }
{.$DEFINE DRAGDROP}

{.$DEFINE DRAGDROP300}
{$DEFINE DRAGDROP400}

{.$DEFINE USESTATICTEXT}

interface

uses
  Windows, Messages, {SysUtils,} Forms, Classes, Graphics, Controls, { Dialogs,}
  StdCtrls, ShellAPI, Menus, Clipbrd
{$IFDEF DRAGDROP}
{$IFDEF DRAGDROP300}
  ,DropSource, DropURLSource
{$ENDIF DRAGDROP300}
{$IFDEF DRAGDROP400}
  ,DragDrop, DropSource, DragDropText, DragDropInternet
{$ENDIF DRAGDROP400}
{$ENDIF}
  ;

const
  MAX_LANGUAGES = 6;
  OPEN_ITEM = 0;
  COPYTOCLIPBOARD_ITEM = 2;
  SHOWURL_ITEM = OPEN_ITEM;

  DefaultCaptureMouse = False;

resourcestring
  SUntitled = 'Untitled';

type
  TWMCaptureChanged = packed record
    Msg: Cardinal;
    WParam: Longint;
    hwndNewCapture: THandle;
    Result: Longint;
  end;

  TExecuteThread = class;

  TBcWebLabelLanguages = (wlFinnish, wlEnglish, wlItalian, wlDutch, wlGerman,
    wlIcelandic);
  TBcWebLabelLanguageString = (lsOpen, lsCopyToClipboard);
  TShowURL = (suNone, suURL, suCaption, suHint);
  TOpenStyle = (osDefault, osMaximized, osCustom);
  TItemStrings = array[TBcWebLabelLanguages, TBcWebLabelLanguageString] of string;

  { event type must be procedure of object, not normal procedure. }
  TExecuteEvent = procedure(Sender: TObject; var AllowExecute: boolean) of object;

{$IFDEF USESTATICTEXT}
  TBcWebLabel = class(TStaticText)
{$ELSE}
  TBcWebLabel = class(TLabel)
{$ENDIF}
  private
    { Private declarations }
    FRunBrowser: boolean;
    FURL: string;
    FLFont,
    FAFont,
    FHFont: TFont;
    FPressed: boolean;
    FMouseIn: boolean;
    FUsePopUp: boolean;
    FHotTrack: boolean;
    FOpenStyle: TOpenStyle;
    FOnMouseEnter,FOnMouseLeave: TNotifyEvent;
    FOnExecute: TExecuteEvent;

    FClipboardText: string;
    FLanguage: TBcWebLabelLanguages;
    FCustomLanguage: TStringList;
    FShowURL: TShowURL;
    FPopup: TPopupMenu;
    ExecuteThread: TExecuteThread;

    FCaptureMouse: Boolean;
    FHandle: THandle;
    FCaptureIsSet: Boolean;

{$IFDEF DRAGDROP}
    FDragDrop: boolean;
    TextSource: TDropTextSource;
    URLSource: TDropURLSource;
    procedure Dropped(Sender: TObject; DragType: TDragType; var ContinueDrop: Boolean);
{$ENDIF}

    procedure SetRunBrowser(Value: boolean);
    procedure SetUsePopup(Value: boolean);
    procedure SetURL(Value: string);
{    procedure SetFLFont(Value: TFont);}
    procedure SetFAFont(Value: TFont);
    procedure SetFHFont(Value: TFont);

    procedure SetFLanguage(Value: TBcWebLabelLanguages);
    procedure SetFCustomLanguage(Value: TStringList);
    procedure UpdatePopupMenuLanguage;
    procedure UpdateShowURLItem;
    procedure RunBrowser(Sender: TObject);
    procedure CopyLinkToClipboard(Sender: TObject);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
    procedure SetCaptureMouse(const Value: Boolean);
{$IFDEF USESTATICTEXT}

{$ENDIF}
  protected
    { Protected declarations }
{$IFDEF USESTATICTEXT}
    FCanvas: TCanvas;
{$ENDIF}

    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure CaptureProc(var Message: TMessage);
    procedure CreateCaptureHandle;
    procedure FreeCaptureHandle;

{$IFDEF USESTATICTEXT}
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    property Canvas: TCanvas read FCanvas;
{$ENDIF}
  public
    { Public declarations }
{$IFDEF USESTATICTEXT}
    procedure Paint;
{$ENDIF}
    constructor Create(AOwner: TComponent);  override;
    destructor Destroy; override;
    procedure GotoURL;
    property MouseIn: boolean read FMouseIn;
  published
    { Published declarations }
    property RunDefaultBrowser: boolean read FRunBrowser write SetRunBrowser default True;
    property UsePopup: boolean read FUsePopup write SetUsePopup default True;
    property ShowURL: TShowURL read FShowURL write FShowURL default suNone;
    property OpenStyle: TOpenStyle read FOpenStyle write FOpenStyle default osDefault;
    property URL: string read FURL write SetURL;
    property ActiveFont: TFont read FAFont write SetFAFont;
    property HotTrackFont: TFont read FHFont write SetFHFont;
    property HotTrack: boolean read FHotTrack write FHotTrack default False;
    property CustomLanguage: TStringList read FCustomLanguage write SetFCustomLanguage;
    property Language: TBcWebLabelLanguages read FLanguage write SetFLanguage default wlEnglish;
    property ClipboardText: string read FClipboardText write FClipboardText;
    property CaptureMouse: Boolean read FCaptureMouse write SetCaptureMouse default DefaultCaptureMouse;
{$IFDEF DRAGDROP}
    property DragURL: boolean read FDragDrop write FDragDrop default True;
{$ENDIF}
{$IFDEF USESTATICTEXT}
    property TabStop default True;
{$ENDIF}
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
    property OnExecute: TExecuteEvent read FOnExecute write FOnExecute;
  end;

  TExecuteThread = class(TThread)
  public
    URL: string;
    Style: Longint;
    procedure Start;
    procedure Finish;
    procedure Execute; override;
  end;

var
  ItemStrings: TItemStrings;

implementation

uses SysUtils;

constructor TBcWebLabel.Create(AOwner: TComponent);
var
  s1, s2: string;
  Item1, Item2, Item3: TMenuItem;
begin
  inherited Create(AOwner);
{$IFDEF USESTATICTEXT}
  FCanvas := TCanvas.Create;
  TabStop := True;
  DoubleBuffered := True;
{$ENDIF}

  FRunBrowser := True;
  FURL := '';
  FUsePopup := True;

  FMouseIn := False;
  CaptureMouse := DefaultCaptureMouse;

  Font.Color := clBlue;
  Font.Style := [fsUnderline];

  FLFont := TFont.Create;
  FAFont := TFont.Create;
  FHFont := TFont.Create;

  FLFont.Assign(Font);
  FAFont.Color := clRed;
  FAFont.Style := [fsUnderline];
  FHFont.Color := clRed;
  FHFont.Style := [fsUnderline];
{  FLFont.Assign(Font);
  ActiveFont.Color := clRed;
  ActiveFont.Style := [fsUnderline];
  HotTrackFont.Color := clRed;
  HotTrackFont.Style := [fsUnderline];}
  Cursor := crHandPoint; { default handpoint }
  FHotTrack := False;
  FOpenStyle := osDefault;
  FLanguage := wlEnglish;
  FShowURL := suNone;
  FCustomLanguage := TStringList.Create;
 { Transparent := True; }

  { set language strings }
  if (FCustomLanguage.Count >= 1) then
    s1 := FCustomLanguage[0]
  else
    s1 := ItemStrings[FLanguage][lsOpen];
  if (FCustomLanguage.Count >= 2) then
    s2 := FCustomLanguage[1]
  else
    s2 := ItemStrings[FLanguage][lsCopyToClipboard];

  { let's create popupmenu dynamically }
  FPopup := TPopupMenu.Create(Self);
  with FPopup do
  begin
    Item1 := TMenuItem.Create(Self);
    Item1.Caption := s1;
    Item1.Default := True;
    Item1.OnClick := RunBrowser;
    Item2 := TMenuItem.Create(Self);
    Item2.Caption := '-';
    Item3 := TMenuItem.Create(Self);
    Item3.Caption := s2;
    Item3.OnClick := CopyLinkToClipboard;
    Items.Add(Item1);
    Items.Add(Item2);
    Items.Add(Item3);
  end;

{$IFDEF DRAGDROP}
  FDragDrop := True;
  TextSource := TDropTextSource.Create(Self);
  URLSource := TDropURLSource.Create(Self);
  TextSource.OnDrop := Dropped;
  URLSource.OnDrop := Dropped;
{$ENDIF}
end;

destructor TBcWebLabel.Destroy;
begin
  FreeCaptureHandle;
  FreeAndNil(FCustomLanguage);
  FreeAndNil(FLFont);
  FreeAndNil(FAFont);
  FreeAndNil(FHFont);
{$IFDEF DRAGDROP}
  FreeAndNil(TextSource);
  FreeAndNil(URLSource);
{$ENDIF}
{$IFDEF USESTATICTEXT}
  FreeAndNil(FCanvas);
{$ENDIF}
  inherited Destroy;
end;

procedure TBcWebLabel.GotoURL;
begin
  RunBrowser(nil);
end;

procedure TBcWebLabel.UpdatePopupMenuLanguage;
begin
  if (FCustomLanguage.Count >= 1) then
    FPopup.Items[OPEN_ITEM].Caption := FCustomLanguage[0]
  else
    FPopup.Items[OPEN_ITEM].Caption := ItemStrings[FLanguage][lsOpen];
  if (FCustomLanguage.Count >= 2) then
    FPopup.Items[COPYTOCLIPBOARD_ITEM].Caption := FCustomLanguage[1]
  else
    FPopup.Items[COPYTOCLIPBOARD_ITEM].Caption := ItemStrings[FLanguage][lsCopyToClipboard];
end;

procedure TBcWebLabel.UpdateShowURLItem;
var s: string;
begin
  if (FShowURL = suNone) then Exit;

  case FShowURL of
  suURL:     if (FURL <> '')    then s := FURL    else s := '??';
  suCaption: if (Caption <> '') then s := Caption else s := '??';
  suHint:    if (Hint <> '')    then s := Hint    else s := '??';
  end;
  FPopup.Items[SHOWURL_ITEM].Caption :=
    FPopup.Items[SHOWURL_ITEM].Caption+' ('+s+')';
end;

procedure TBcWebLabel.SetRunBrowser(Value: boolean);
begin
  if FRunBrowser <> Value then FRunBrowser := Value;
end;

procedure TBcWebLabel.SetUsePopup(Value: boolean);
begin
  if FUsePopup <> Value then FUsePopup := Value;
end;

procedure TBcWebLabel.SetURL(Value: String);
begin
  if FURL <> Value then
  begin
    FURL := Value;
    if Caption='' then Caption := Value;
  end;
end;

procedure TBcWebLabel.SetFAFont(Value: TFont);
begin
  FAFont.Assign(Value);
end;

procedure TBcWebLabel.SetFHFont(Value: TFont);
begin
  FHFont.Assign(Value);
end;

procedure TBcWebLabel.SetFLanguage(Value: TBcWebLabelLanguages);
begin
  if FLanguage <> Value then
  begin
    FLanguage := Value;
    UpdatePopupMenuLanguage;
  end;
end;

procedure TBcWebLabel.SetFCustomLanguage(Value: TStringList);
begin
  FCustomLanguage.Assign(Value);
  UpdatePopupMenuLanguage;
end;

procedure TBcWebLabel.CMMouseEnter(var Message: TMessage);
begin
  FMouseIn := True;
  FLFont.Assign(Font);
  if (FPressed) then
    Font.Assign(FAFont)
  else if FHotTrack then
    Font.Assign(FHFont);

  if Assigned(FOnMouseEnter) then FOnMouseEnter(Self);
end;

{$IFDEF DRAGDROP}
procedure TBcWebLabel.Dropped(Sender: TObject; DragType: TDragType;
  var ContinueDrop: Boolean);
begin
  FPressed := False;
end;
{$ENDIF}

procedure TBcWebLabel.CMMouseLeave(var Message: TMessage);
{$IFDEF DRAGDROP}
var s: string;
{$ENDIF}
begin
 { inherited; }

  if (FPressed) or FHotTrack then
    Font.Assign(FLFont);
  if Assigned(FOnMouseLeave) then FOnMouseLeave(Self);
{$IFDEF DRAGDROP}
  case FShowURL of
  suURL:     if (FURL <> '')    then s := FURL    else s := SUntitled;
  suCaption: if (Caption <> '') then s := Caption else s := SUntitled;
  suHint:    if (Hint <> '')    then s := Hint    else s := SUntitled;
  else
    s := FURL;
  end;
  if (FPressed and FDragDrop and ((FClipboardText <> '') or (s <> ''))) then
  begin
    if FClipboardText = '' then
    begin
      URLSource.URL := FURL;
      URLSource.Title := s;
      URLSource.Execute;
    end
    else
    begin
      TextSource.Text := FClipboardText;
      TextSource.Execute;
    end;
    FPressed := False;
  end;
{$ENDIF}
  FMouseIn := False;
end;

procedure TBcWebLabel.WMLButtonDown(var Message: TWMLButtonDown);
begin

  if not FHotTrack then FLFont.Assign(Font);
  Font.Assign(FAFont);
  FPressed := True;

  inherited;

  Repaint;
end;

procedure TBcWebLabel.CopyLinkToClipboard(Sender: TObject);
begin
//  if not Clipboard.HasFormat(CF_TEXT) then
//    Windows.RegisterClipboardFormat('CF_TEXT');

  if FClipboardText = '' then
    Clipboard.AsText := FURL
  else
    Clipboard.AsText := FClipboardText;
end;

procedure TExecuteThread.Start;
begin
  Screen.Cursor := crAppStart;
end;

procedure TExecuteThread.Finish;
begin
  Screen.Cursor := crDefault;
end;

procedure TExecuteThread.Execute;
begin
  Synchronize(Start);
  ShellExecute(0{Application.Handle}, 'open', PChar(URL), nil, nil, Style);
  Synchronize(Finish);
end;

procedure TBcWebLabel.RunBrowser(Sender: TObject);
var Style: Longint;
begin
  case FOpenStyle of
    osDefault:   Style := SW_SHOWDEFAULT;
    osMaximized: Style := SW_SHOWMAXIMIZED;
    osCustom:    Style := Tag;
  else
    Style := SW_SHOWDEFAULT;
  end;
  if (Sender = nil) or (FRunbrowser and (FURL <> '') and FMouseIn) then
  begin
    ExecuteThread := TExecuteThread.Create(True);
    ExecuteThread.URL := FURL;
    ExecuteThread.Style := Style;
    ExecuteThread.Priority := tpNormal;
    ExecuteThread.FreeOnTerminate := True;
    ExecuteThread.Resume;
  end;
end;

procedure TBcWebLabel.WMLButtonUp(var Message: TWMLButtonUp);
var AllowExecute: Boolean;
begin
  if (FHotTrack and FMouseIn) then
    Font.Assign(FHFont)
  else
    Font.Assign(FLFont);
  FPressed := False;

  inherited;

  Repaint;

  AllowExecute := True;
  if Assigned(FOnExecute) then FOnExecute(Self, AllowExecute);
  if AllowExecute then
    RunBrowser(Self);
  Click;
end;

procedure TBcWebLabel.WMRButtonUp(var Message: TWMRButtonUp);
var p: TPoint;
begin
  inherited; 
  if FUsePopup then
  begin
    Font.Assign(FAFont);
    FPressed := True;
    Repaint;
    Screen.Cursor := crDefault;

    GetCursorPos(p);
    UpdatePopupMenuLanguage;
    UpdateShowURLItem;
    FPopup.Popup(p.X, p.Y);

    Font.Assign(FLFont);
    FPressed := False;
    Repaint;
  end else
    Click;
end;

procedure TBcWebLabel.SetCaptureMouse(const Value: Boolean);
begin
  FCaptureMouse := Value;
  if not (csDesigning in ComponentState) then
    if Value then
      CreateCaptureHandle
    else
      FreeCaptureHandle;
end;

procedure TBcWebLabel.CreateCaptureHandle;
begin
  if FHandle = 0 then
{$IFDEF USESTATICTEXT}
    FHandle := Handle;
{$ELSE}
    FHandle := AllocateHWnd(CaptureProc);
{$ENDIF}
end;

procedure TBcWebLabel.FreeCaptureHandle;
begin
  if FHandle <> 0 then
  begin
    FMouseIn := False;

    ReleaseCapture;

{$IFNDEF USESTATICTEXT}
    DeallocateHWnd(FHandle);
{$ENDIF}
    FHandle := 0;
  end;
end;

procedure TBcWebLabel.CaptureProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_CAPTURECHANGED:
      begin
        with TWMCaptureChanged(Message) do
        begin
          FMouseIn := False;
          FCaptureIsSet := False;
          Font.Assign(FLFont);
//          Perform(CM_MOUSELEAVE, 0, Longint(Self));
        end;
      end;
    WM_MOUSEFIRST..WM_MOUSELAST:
      begin
        if Message.Msg = WM_MOUSEMOVE then
        begin
          with TWMMouseMove(Message) do
          begin
            if FCaptureMouse and (FHandle <> 0) then
            begin
              if FMouseIn then
              begin
                if not PtInRect(
                  Rect(Left, Top, Left + Width, Top + Height),
                  Point(XPos, YPos)) then
                begin
                  ReleaseCapture;
                  FCaptureIsSet := False;
                  Perform(CM_MOUSELEAVE, 0, Longint(Self));
                end;
              end;
            end;
          end;
        end else
          with Message do Perform(Msg, WParam, LParam);
      end;
  end;
  with Message do
    Result := DefWindowProc(FHandle, Msg, wParam, lParam);
end;

procedure TBcWebLabel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseMove(Shift, X, Y);
  if FCaptureMouse then
  begin
    if not FCaptureIsSet then
    begin
      SetCapture(FHandle);
      FCaptureIsSet := True;
    end;
    FMouseIn := True;
    Perform(CM_MOUSEENTER, 0, Longint(Self));
  end;
end;

{$IFDEF USESTATICTEXT}
procedure TBcWebLabel.WMPaint(var Message: TWMPaint);
begin
  inherited;
//  if Message.DC = 0 then
//  if Message.DC <> 0 then
  begin
    try
      Canvas.Handle := GetDC(Handle);
//      Canvas.Handle := Message.DC;
      Paint;
    finally
      ReleaseDC(Handle, Canvas.Handle);
      Canvas.Handle := 0;
    end;
  end;
end;

procedure TBcWebLabel.WMSetFocus(var Message: TWMSetFocus);
begin
  inherited;
  Repaint;
end;

procedure TBcWebLabel.WMKillFocus(var Message: TWMKillFocus);
begin
  inherited;
  Repaint;
end;

procedure TBcWebLabel.WMEraseBkgnd(var Message: TWMEraseBkgnd);
var OldHandle: HDC;
begin
//  OldHandle := Canvas.Handle;
  try
//    Canvas.Handle := Message.DC;
//    if Focused then Paint; // xor remove
  finally
//    Canvas.Handle := OldHandle;
  end;
  Message.Result := 1;
//  inherited;
end;

procedure TBcWebLabel.Paint;
{var
  FocusRectSize: TSize;
  R: TRect;}
begin
  if Focused then
    with Canvas do
    begin
{      Font.Assign(Self.Font);
      FocusRectSize := TextExtent(Caption);
      R := ClientRect;
      R.Right := R.Left + FocusRectSize.cx + 4;
      R.Bottom := R.Top + FocusRectSize.cy + 4;
      DrawFocusRect(R);}
{      Brush.Color := clBtnFace;
      FrameRect(R);}
      DrawFocusRect(ClientRect);
    end;
end;
{$ENDIF}

initialization
  { [0] Open/Activate the link
    [1] Copy URL to clipboard }

  { initialize language array }
  ItemStrings[wlFinnish][lsOpen] := '&Avaa';
  ItemStrings[wlFinnish][lsCopyToClipboard] := '&Kopioi leikepydlle';
  ItemStrings[wlEnglish][lsOpen] := '&Open';
  ItemStrings[wlEnglish][lsCopyToClipboard] := '&Copy to clipboard';
  ItemStrings[wlItalian][lsOpen] := '&Apri';
  ItemStrings[wlItalian][lsCopyToClipboard] := '&Copia negli appunti';
  ItemStrings[wlDutch][lsOpen] := '&Open';
  ItemStrings[wlDutch][lsCopyToClipboard] := '&Kopieer Naar Clipboard';
  ItemStrings[wlGerman][lsOpen] := '&ffnen';
  ItemStrings[wlGerman][lsCopyToClipboard] := 'In die Zwischenablage &kopieren';
  ItemStrings[wlIcelandic][lsOpen] := '&Opna';
  ItemStrings[wlIcelandic][lsCopyToClipboard] := '&Aftria  geymslusvi';

finalization

end.
